com.independentsoft.exchange

## Class AutodiscoverService

- java.lang.Object
- - com.independentsoft.exchange.AutodiscoverService

-     public class AutodiscoverService
      extends java.lang.Object

  The Class AutodiscoverService.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AutodiscoverService()` Instantiates a new autodiscover service.
    `AutodiscoverService(java.lang.String url)` Instantiates a new autodiscover service.
    `AutodiscoverService(java.lang.String url, java.lang.String username, java.lang.String password)` Instantiates a new autodiscover service.
    `AutodiscoverService(java.lang.String url, java.lang.String username, java.lang.String password, java.lang.String domain)` Instantiates a new autodiscover service.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `MobileSyncProvider` | `autodiscoverMobileSyncProvider(java.lang.String emailAddress)` Autodiscover mobile sync provider.
    `OutlookProvider` | `autodiscoverOutlookProvider(java.lang.String emailAddress)` Autodiscover outlook provider.
    `org.apache.http.conn.HttpClientConnectionManager` | `getClientConnectionManager()` Gets connection manager.
    `int` | `getConnectTimeout()` Returns setting for connect timeout.
    `org.apache.http.Header[]` | `getCustomHeaders()`
    `java.lang.String` | `getDomain()` Gets user's domain.
    `GetDomainSettingsResponse` | `getDomainSettings(java.util.List<java.lang.String> domains, java.util.List<DomainSettingName> settingNames)` Gets the domain settings.
    `GetDomainSettingsResponse` | `getDomainSettings(java.lang.String domain, DomainSettingName settingName)` Gets the domain settings.
    `GetDomainSettingsResponse` | `getDomainSettings(java.lang.String domain, java.util.List<DomainSettingName> settingNames)` Gets the domain settings.
    `Identity` | `getExchangeImpersonation()` Gets the ID of the user that Exchange Web Services (EWS) should impersonate.
    `GetFederationInformationResponse` | `getFederationInformation(java.lang.String domain)` Gets the federation information.
    `java.net.Proxy` | `getHttpURLConnectionProxy()` Gets HttpURLConnection proxy server.
    `java.lang.String` | `getMailboxCulture()` Gets the mailbox culture that is used when opening a mailbox.
    `java.lang.String` | `getPassword()` Gets user's password.
    `org.apache.http.HttpHost` | `getProxy()` Gets HttpClient proxy.
    `org.apache.http.auth.Credentials` | `getProxyCredentials()` Gets proxy credentials.
    `int` | `getReadTimeout()` Returns setting for read timeout.
    `org.apache.http.client.config.RequestConfig` | `getRequestConfig()` Gets request configuration.
    `RequestServerVersion` | `getRequestServerVersion()` Gets the versioning information that identifies the schema version to target for a request.
    `java.lang.String` | `getUrl()` Gets URL of Exchange Web Services.
    `java.lang.String` | `getUsername()` Gets username.
    `GetUserSettingsResponse` | `getUserSettings(java.util.List<java.lang.String> emailAddresses, java.util.List<UserSettingName> settingNames)` Gets the user settings.
    `GetUserSettingsResponse` | `getUserSettings(java.lang.String emailAddress, java.util.List<UserSettingName> settingNames)` Gets the user settings.
    `GetUserSettingsResponse` | `getUserSettings(java.lang.String emailAddress, UserSettingName settingName)` Gets the user settings.
    `void` | `setClientConnectionManager(org.apache.http.conn.HttpClientConnectionManager connectionManager)` Sets connection manager.
    `void` | `setConnectTimeout(int connectTimeout)` Sets the specified timeout value, in milliseconds, to be used when opening a communications link to the resource referenced by the HttpURLConnection.
    `void` | `setCustomHeaders(org.apache.http.Header[] customHeaders)`
    `void` | `setDomain(java.lang.String domain)` Sets user's domain.
    `void` | `setExchangeImpersonation(Identity identity)` Sets the ID of the user that Exchange Web Services (EWS) should impersonate.
    `void` | `setHttpURLConnection(boolean useHttpURLConnection)` Sets the http url connection.
    `void` | `setHttpURLConnectionProxy(java.net.Proxy httpURLConnectionProxy)` Sets HttpURLConnection proxy server.
    `void` | `setMailboxCulture(java.lang.String mailboxCulture)` Sets the mailbox culture that is used when opening a mailbox.
    `void` | `setPassword(java.lang.String password)` Sets user's password.
    `void` | `setProxy(org.apache.http.HttpHost proxy)` Sets HttpClient proxy.
    `void` | `setProxyCredentials(org.apache.http.auth.Credentials proxyCredentials)` Sets proxy credentials.
    `void` | `setReadTimeout(int readTimeout)` Sets the read timeout to the specified timeout, in milliseconds.
    `void` | `setRequestConfig(org.apache.http.client.config.RequestConfig requestConfig)` Sets request configuration.
    `void` | `setRequestServerVersion(RequestServerVersion requestServerVersion)` Sets the versioning information that identifies the schema version to target for a request.
    `void` | `setUrl(java.lang.String url)` Sets URL of Exchange Web Services.
    `void` | `setUsername(java.lang.String username)` Sets username.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AutodiscoverService

          public AutodiscoverService()

      Instantiates a new autodiscover service.

    - #### AutodiscoverService

          public AutodiscoverService(java.lang.String url)

      Instantiates a new autodiscover service.
      Parameters:
        `url` - the url

    - #### AutodiscoverService

          public AutodiscoverService(java.lang.String url,
                                     java.lang.String username,
                                     java.lang.String password)

      Instantiates a new autodiscover service.
      Parameters:
        `url` - the url
        `username` - the username
        `password` - the password

    - #### AutodiscoverService

          public AutodiscoverService(java.lang.String url,
                                     java.lang.String username,
                                     java.lang.String password,
                                     java.lang.String domain)

      Instantiates a new autodiscover service.
      Parameters:
        `url` - the url
        `username` - the username
        `password` - the password
        `domain` - the domain

  - ### Method Detail

    - #### autodiscoverMobileSyncProvider

          public MobileSyncProvider autodiscoverMobileSyncProvider(java.lang.String emailAddress)
                                                            throws ServiceException,
                                                                   AutodiscoverException

      Autodiscover mobile sync provider.
      Parameters:
        `emailAddress` - the email address
      Returns:
        the mobile sync provider
      Throws:
        `ServiceException` - the service exception
        `AutodiscoverException` - the autodiscover exception

    - #### getUserSettings

          public GetUserSettingsResponse getUserSettings(java.lang.String emailAddress,
                                                         UserSettingName settingName)
                                                  throws ServiceException,
                                                         AutodiscoverException

      Gets the user settings.
      Parameters:
        `emailAddress` - the email address
        `settingName` - the setting name
      Returns:
        the user settings
      Throws:
        `ServiceException` - the service exception
        `AutodiscoverException` - the autodiscover exception

    - #### getUserSettings

          public GetUserSettingsResponse getUserSettings(java.lang.String emailAddress,
                                                         java.util.List<UserSettingName> settingNames)
                                                  throws ServiceException,
                                                         AutodiscoverException

      Gets the user settings.
      Parameters:
        `emailAddress` - the email address
        `settingNames` - the setting names
      Returns:
        the user settings
      Throws:
        `ServiceException` - the service exception
        `AutodiscoverException` - the autodiscover exception

    - #### getUserSettings

          public GetUserSettingsResponse getUserSettings(java.util.List<java.lang.String> emailAddresses,
                                                         java.util.List<UserSettingName> settingNames)
                                                  throws ServiceException,
                                                         AutodiscoverException

      Gets the user settings.
      Parameters:
        `emailAddresses` - the email addresses
        `settingNames` - the setting names
      Returns:
        the user settings
      Throws:
        `ServiceException` - the service exception
        `AutodiscoverException` - the autodiscover exception

    - #### getDomainSettings

          public GetDomainSettingsResponse getDomainSettings(java.lang.String domain,
                                                             DomainSettingName settingName)
                                                      throws ServiceException,
                                                             AutodiscoverException

      Gets the domain settings.
      Parameters:
        `domain` - the domain
        `settingName` - the setting name
      Returns:
        the domain settings
      Throws:
        `ServiceException` - the service exception
        `AutodiscoverException` - the autodiscover exception

    - #### getDomainSettings

          public GetDomainSettingsResponse getDomainSettings(java.lang.String domain,
                                                             java.util.List<DomainSettingName> settingNames)
                                                      throws ServiceException,
                                                             AutodiscoverException

      Gets the domain settings.
      Parameters:
        `domain` - the domain
        `settingNames` - the setting names
      Returns:
        the domain settings
      Throws:
        `ServiceException` - the service exception
        `AutodiscoverException` - the autodiscover exception

    - #### getDomainSettings

          public GetDomainSettingsResponse getDomainSettings(java.util.List<java.lang.String> domains,
                                                             java.util.List<DomainSettingName> settingNames)
                                                      throws ServiceException,
                                                             AutodiscoverException

      Gets the domain settings.
      Parameters:
        `domains` - the domains
        `settingNames` - the setting names
      Returns:
        the domain settings
      Throws:
        `ServiceException` - the service exception
        `AutodiscoverException` - the autodiscover exception

    - #### getFederationInformation

          public GetFederationInformationResponse getFederationInformation(java.lang.String domain)
                                                                    throws ServiceException,
                                                                           AutodiscoverException

      Gets the federation information.
      Parameters:
        `domain` - the domain
      Returns:
        the federation information
      Throws:
        `ServiceException` - the service exception
        `AutodiscoverException` - the autodiscover exception

    - #### autodiscoverOutlookProvider

          public OutlookProvider autodiscoverOutlookProvider(java.lang.String emailAddress)
                                                      throws ServiceException,
                                                             AutodiscoverException

      Autodiscover outlook provider.
      Parameters:
        `emailAddress` - the email address
      Returns:
        the outlook provider
      Throws:
        `ServiceException` - the service exception
        `AutodiscoverException` - the autodiscover exception

    - #### getUrl

          public java.lang.String getUrl()

      Gets URL of Exchange Web Services.
      Returns:
        the url

    - #### setUrl

          public void setUrl(java.lang.String url)

      Sets URL of Exchange Web Services.
      Parameters:
        `url` - the new url

    - #### getUsername

          public java.lang.String getUsername()

      Gets username.
      Returns:
        the username

    - #### setUsername

          public void setUsername(java.lang.String username)

      Sets username.
      Parameters:
        `username` - the new username

    - #### getPassword

          public java.lang.String getPassword()

      Gets user's password.
      Returns:
        the password

    - #### setPassword

          public void setPassword(java.lang.String password)

      Sets user's password.
      Parameters:
        `password` - the new password

    - #### getDomain

          public java.lang.String getDomain()

      Gets user's domain.
      Returns:
        the domain

    - #### setDomain

          public void setDomain(java.lang.String domain)

      Sets user's domain.
      Parameters:
        `domain` - the new domain

    - #### getMailboxCulture

          public java.lang.String getMailboxCulture()

      Gets the mailbox culture that is used when opening a mailbox.
      Returns:
        the mailbox culture

    - #### setMailboxCulture

          public void setMailboxCulture(java.lang.String mailboxCulture)

      Sets the mailbox culture that is used when opening a mailbox.
      Parameters:
        `mailboxCulture` - the new mailbox culture

    - #### getExchangeImpersonation

          public Identity getExchangeImpersonation()

      Gets the ID of the user that Exchange Web Services (EWS) should impersonate.
      Returns:
        the exchange impersonation

    - #### setExchangeImpersonation

          public void setExchangeImpersonation(Identity identity)

      Sets the ID of the user that Exchange Web Services (EWS) should impersonate.
      Parameters:
        `identity` - the new exchange impersonation

    - #### getRequestServerVersion

          public RequestServerVersion getRequestServerVersion()

      Gets the versioning information that identifies the schema version to target for a request.
      Returns:
        the request server version

    - #### setRequestServerVersion

          public void setRequestServerVersion(RequestServerVersion requestServerVersion)

      Sets the versioning information that identifies the schema version to target for a request.
      Parameters:
        `requestServerVersion` - the new request server version

    - #### getHttpURLConnectionProxy

          public java.net.Proxy getHttpURLConnectionProxy()

      Gets HttpURLConnection proxy server.
      Returns:
        the http url connection proxy

    - #### setHttpURLConnectionProxy

          public void setHttpURLConnectionProxy(java.net.Proxy httpURLConnectionProxy)

      Sets HttpURLConnection proxy server.
      Parameters:
        `httpURLConnectionProxy` - the new http url connection proxy

    - #### getProxy

          public org.apache.http.HttpHost getProxy()

      Gets HttpClient proxy.
      Returns:
        the proxy

    - #### setProxy

          public void setProxy(org.apache.http.HttpHost proxy)

      Sets HttpClient proxy.
      Parameters:
        `proxy` - the new proxy

    - #### getProxyCredentials

          public org.apache.http.auth.Credentials getProxyCredentials()

      Gets proxy credentials.
      Returns:
        the proxy credentials

    - #### setProxyCredentials

          public void setProxyCredentials(org.apache.http.auth.Credentials proxyCredentials)

      Sets proxy credentials.
      Parameters:
        `proxyCredentials` - the new proxy credentials

    - #### getClientConnectionManager

          public org.apache.http.conn.HttpClientConnectionManager getClientConnectionManager()

      Gets connection manager.
      Returns:
        the client connection manager

    - #### setClientConnectionManager

          public void setClientConnectionManager(org.apache.http.conn.HttpClientConnectionManager connectionManager)

      Sets connection manager.
      Parameters:
        `connectionManager` - the new client connection manager

    - #### getRequestConfig

          public org.apache.http.client.config.RequestConfig getRequestConfig()

      Gets request configuration.
      Returns:
        the request configuration

    - #### setRequestConfig

          public void setRequestConfig(org.apache.http.client.config.RequestConfig requestConfig)

      Sets request configuration.
      Parameters:
        `requestConfig` - the request configuration

    - #### setHttpURLConnection

          public void setHttpURLConnection(boolean useHttpURLConnection)

      Sets the http url connection.
      Parameters:
        `useHttpURLConnection` - the new http url connection

    - #### setConnectTimeout

          public void setConnectTimeout(int connectTimeout)

      Sets the specified timeout value, in milliseconds, to be used when opening a communications link to the resource referenced by the HttpURLConnection. If the timeout expires before the connection can be established, a java.net.SocketTimeoutException is raised. A timeout of zero is interpreted as an infinite timeout.
      Parameters:
        `connectTimeout` - the new connect timeout

    - #### getConnectTimeout

          public int getConnectTimeout()

      Returns setting for connect timeout. 0 return implies that the option is disabled (i.e., timeout of infinity).
      Returns:
        the connect timeout

    - #### setReadTimeout

          public void setReadTimeout(int readTimeout)

      Sets the read timeout to the specified timeout, in milliseconds. A non-zero value specifies the timeout when reading from Input stream when a connection is established to a resource. If the timeout expires before there is data available for read, a java.net.SocketTimeoutException is raised. A timeout of zero is interpreted as an infinite timeout.
      Parameters:
        `readTimeout` - the new read timeout

    - #### getReadTimeout

          public int getReadTimeout()

      Returns setting for read timeout. 0 return implies that the option is disabled (i.e., timeout of infinity).
      Returns:
        the read timeout

    - #### setCustomHeaders

          public void setCustomHeaders(org.apache.http.Header[] customHeaders)

    - #### getCustomHeaders

          public org.apache.http.Header[] getCustomHeaders()